Ueberweisung
Date: 2015-04-26

de.jost_net.OBanToo.SEPA.Ueberweisung

## Class Ueberweisung

- java.lang.Object
- - de.jost_net.OBanToo.SEPA.Ueberweisung.Ueberweisung

-     public class Ueberweisung
      extends java.lang.Object

  Author:
    heiner

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `private java.lang.String` | `anzahlbuchungen` Anzahl Buchungen (read-only)
    `private java.lang.String` | `bic` BIC des Auftraggebers
    `private java.util.Date` | `creationdatetime` Datum und Uhrzeit der Erzeugung der Datei
    `private java.util.Date` | `dateofexecution` Datum der Ausführung
    `private java.util.ArrayList<Empfaenger>` | `empfaengerarray` Array von Empfängern
    `private java.lang.String` | `iban` IBAN des Auftraggebers
    `private java.math.BigDecimal` | `kontrollsumme` Kontrollsumme
    `private java.lang.String` | `messageID` Message-ID für die Prüfung auf Doppeleinreichung
    `private java.lang.String` | `name` Name des Auftraggebers
    `private boolean` | `sammelbuchung` Sammelbuchung?

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Ueberweisung()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `add(Empfaenger empfaenger)` Für jede Buchung wird ein Zahler-Object übergeben
    `java.lang.String` | `getAnzahlBuchungen()` Anzahl der Buchungen.
    `java.util.Date` | `getAusfuehrungsdatum()` Gew�nschtes Ausf�hrungsdatum.
    `java.lang.String` | `getBIC()`
    `java.util.Date` | `getCreationDateTime()` Datum der Erzeugung der Datei.
    `private CreditTransferTransactionInformationSCT` | `getCreditTransferTransactionInformationSCT(Empfaenger e)`
    `private CustomerCreditTransferInitiationV03` | `getCustumerCreditTransferInitiationV03()` SEPA-Datei einlesen.
    `private GroupHeaderSCT` | `getGroupHeader()`
    `java.lang.String` | `getIBAN()`
    `java.math.BigDecimal` | `getKontrollsumme()` Kontrollsumme aller Buchungen.
    `java.lang.String` | `getMessageID()`
    `java.lang.String` | `getName()`
    `private PaymentInstructionInformationSCT` | `getPaymentInstructionInformationSCT()`
    `private PaymentTypeInformationSCT1` | `getPaymentTypeInformationSCT1()`
    `private static javax.xml.datatype.XMLGregorianCalendar` | `getYYYMMDD(java.util.Date date)`
    `private static javax.xml.datatype.XMLGregorianCalendar` | `getYYYMMDDHHMMSS(java.util.Date date)`
    `java.util.ArrayList<Empfaenger>` | `getZahler()` Gibt die Zahler nach dem Einlesen zur�ck.
    `(package private) void` | `setAnzahlBuchungen(java.lang.String anzahlbuchungen)`
    `void` | `setAusfuehrungsdatum(java.util.Date dateofexecution)` Gew�nschtes Ausf�hrungsdatum.
    `void` | `setBIC(java.lang.String bic)` BIC.
    `(package private) void` | `setCreationDateTime(java.util.Date creationdatetime)` Datum der Erzeugung der Datei.
    `void` | `setIBAN(java.lang.String iban)` IBAN.
    `(package private) void` | `setKontrollsumme(java.math.BigDecimal kontrollsumme)` Wird nur intern beim einlesen einer Datei genutzt.
    `void` | `setMessageID(java.lang.String messageid)` Message-ID.
    `void` | `setName(java.lang.String name)` Name des Zahlungspflichtigen.
    `void` | `setSammelbuchung(boolean sammelbuchung)`
    `void` | `write(java.io.BufferedOutputStream bos)`
    `void` | `write(java.io.File file)` Schreibt die SEPA-Datei.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### messageID

          private java.lang.String messageID

      Message-ID für die Prüfung auf Doppeleinreichung

    - #### bic

          private java.lang.String bic

      BIC des Auftraggebers

    - #### iban

          private java.lang.String iban

      IBAN des Auftraggebers

    - #### name

          private java.lang.String name

      Name des Auftraggebers

    - #### empfaengerarray

          private java.util.ArrayList<Empfaenger> empfaengerarray

      Array von Empfängern

    - #### sammelbuchung

          private boolean sammelbuchung

      Sammelbuchung? Standardmäßig Einzelbuchung.

    - #### kontrollsumme

          private java.math.BigDecimal kontrollsumme

      Kontrollsumme

    - #### anzahlbuchungen

          private java.lang.String anzahlbuchungen

      Anzahl Buchungen (read-only)

    - #### creationdatetime

          private java.util.Date creationdatetime

      Datum und Uhrzeit der Erzeugung der Datei

    - #### dateofexecution

          private java.util.Date dateofexecution

      Datum der Ausführung

  - ### Constructor Detail

    - #### Ueberweisung

          public Ueberweisung()

  - ### Method Detail

    - #### add

          public void add(Empfaenger empfaenger)

      Für jede Buchung wird ein Zahler-Object übergeben

    - #### setSammelbuchung

          public void setSammelbuchung(boolean sammelbuchung)

    - #### write

          public void write(java.io.File file)
                     throws javax.xml.datatype.DatatypeConfigurationException,
                            SEPAException,
                            javax.xml.bind.JAXBException,
                            java.io.FileNotFoundException

      Schreibt die SEPA-Datei. Vorher sind alle Werte über die set-Methoden sowie die add(Zahler)-Methode übergeben werden.
      Throws:
        `javax.xml.datatype.DatatypeConfigurationException`
        `SEPAException`
        `javax.xml.bind.JAXBException`
        `java.io.FileNotFoundException`

    - #### write

          public void write(java.io.BufferedOutputStream bos)
                     throws javax.xml.bind.JAXBException,
                            javax.xml.datatype.DatatypeConfigurationException,
                            SEPAException

      Throws:
        `javax.xml.bind.JAXBException`
        `javax.xml.datatype.DatatypeConfigurationException`
        `SEPAException`

    - #### getCustumerCreditTransferInitiationV03

          private CustomerCreditTransferInitiationV03 getCustumerCreditTransferInitiationV03()
                                                                                      throws javax.xml.datatype.DatatypeConfigurationException,
                                                                                             SEPAException

      SEPA-Datei einlesen. Nach dem Methodenaufruf k�nnen die Werte �ber die get-Methoden abgefragt werden.
      Throws:
        `javax.xml.datatype.DatatypeConfigurationException`
        `SEPAException`

    - #### getGroupHeader

          private GroupHeaderSCT getGroupHeader()
                                         throws javax.xml.datatype.DatatypeConfigurationException,
                                                SEPAException

      Throws:
        `javax.xml.datatype.DatatypeConfigurationException`
        `SEPAException`

    - #### getPaymentInstructionInformationSCT

          private PaymentInstructionInformationSCT getPaymentInstructionInformationSCT()
                                                                                throws SEPAException,
                                                                                       javax.xml.datatype.DatatypeConfigurationException

      Throws:
        `SEPAException`
        `javax.xml.datatype.DatatypeConfigurationException`

    - #### getYYYMMDD

          private static javax.xml.datatype.XMLGregorianCalendar getYYYMMDD(java.util.Date date)
                                                                     throws javax.xml.datatype.DatatypeConfigurationException

      Throws:
        `javax.xml.datatype.DatatypeConfigurationException`

    - #### getYYYMMDDHHMMSS

          private static javax.xml.datatype.XMLGregorianCalendar getYYYMMDDHHMMSS(java.util.Date date)
                                                                           throws javax.xml.datatype.DatatypeConfigurationException

      Throws:
        `javax.xml.datatype.DatatypeConfigurationException`

    - #### getCreditTransferTransactionInformationSCT

          private CreditTransferTransactionInformationSCT getCreditTransferTransactionInformationSCT(Empfaenger e)
                                                                                              throws SEPAException

      Throws:
        `SEPAException`

    - #### getPaymentTypeInformationSCT1

          private PaymentTypeInformationSCT1 getPaymentTypeInformationSCT1()

    - #### setMessageID

          public void setMessageID(java.lang.String messageid)
                            throws SEPAException

      Message-ID. Z. B. Buchungslaufnummer. Max. 35 Stellen.
      Throws:
        `SEPAException`

    - #### getMessageID

          public java.lang.String getMessageID()
                                        throws SEPAException

      Throws:
        `SEPAException`

    - #### setBIC

          public void setBIC(java.lang.String bic)
                      throws SEPAException

      BIC. L�nge 8 oder 11 Stellen.
      Throws:
        `SEPAException`

    - #### getBIC

          public java.lang.String getBIC()
                                  throws SEPAException

      Throws:
        `SEPAException`

    - #### setIBAN

          public void setIBAN(java.lang.String iban)
                       throws SEPAException

      IBAN. L�nge in Abh�ngigkeit vom Land.
      Throws:
        `SEPAException`

    - #### getIBAN

          public java.lang.String getIBAN()
                                   throws SEPAException

      Throws:
        `SEPAException`

    - #### setName

          public void setName(java.lang.String name)
                       throws SEPAException

      Name des Zahlungspflichtigen. L�nge max. 70 Stellen.
      Throws:
        `SEPAException`

    - #### getName

          public java.lang.String getName()
                                   throws SEPAException

      Throws:
        `SEPAException`

    - #### setKontrollsumme

          void setKontrollsumme(java.math.BigDecimal kontrollsumme)

      Wird nur intern beim einlesen einer Datei genutzt.

    - #### getKontrollsumme

          public java.math.BigDecimal getKontrollsumme()

      Kontrollsumme aller Buchungen. Steht nach dem Einlesen einer Datei zur Verf�gung.
      Returns:
        Kontrollsumme

    - #### getAnzahlBuchungen

          public java.lang.String getAnzahlBuchungen()

      Anzahl der Buchungen. Steht nach dem Einlesen einer Datei zur Verf�gung.
      Returns:
        Anzahl Buchungen

    - #### setAnzahlBuchungen

          void setAnzahlBuchungen(java.lang.String anzahlbuchungen)

    - #### getCreationDateTime

          public java.util.Date getCreationDateTime()

      Datum der Erzeugung der Datei. Steht nach dem Einlesen einer Datei zur Verf�gung.
      Returns:
        Erzeugungsdatum

    - #### setCreationDateTime

          void setCreationDateTime(java.util.Date creationdatetime)

      Datum der Erzeugung der Datei. Wird beim Einlesen einer Datei genutzt.

    - #### getAusfuehrungsdatum

          public java.util.Date getAusfuehrungsdatum()

      Gew�nschtes Ausf�hrungsdatum.
      Returns:
        ausf�hrungsdatum

    - #### setAusfuehrungsdatum

          public void setAusfuehrungsdatum(java.util.Date dateofexecution)

      Gew�nschtes Ausf�hrungsdatum.

    - #### getZahler

          public java.util.ArrayList<Empfaenger> getZahler()

      Gibt die Zahler nach dem Einlesen zur�ck.